﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.5
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private  ReadJsonList As List
	
	Dim PI As Phone
	Dim pi1 As PhoneId
	Dim Bconv As ByteConverter
	Public ParamMap As Map
End Sub

 '**************************Write Txt File *******************************
 
Sub write_file_setup(data As List, file_name As String,append_data As Boolean, Writeconf As Boolean) As ResumableSub
	'
	Dim Writer As TextWriter
	If Writeconf=False Then
		
		If append_data=False Then
			Writer.Initialize(File.OpenOutput(File.DirDefaultExternal, file_name,False))
		Else
			Writer.Initialize(File.OpenOutput(File.DirDefaultExternal, file_name,True))
		End If
	
		Try
		
			For Each info As String In data
				Writer.WriteLine(info)
			Next
							
			Writer.Close
			Return True
		Catch
			ToastMessageShow("Sauvegarde impossible", True)
			Return False
		End Try
	Else
		
		If append_data=False Then
			Writer.Initialize(File.OpenOutput(File.DirDefaultExternal, file_name,False))
		Else
			Writer.Initialize(File.OpenOutput(File.DirDefaultExternal, file_name,True))
		End If
	
		Try
		
			For Each info As String In data
				Writer.WriteLine(info)
			Next
							
			Writer.Close
			Return True
		Catch
			ToastMessageShow("Sauvegarde impossible", True)
			Return False
		End Try
		
	End If
	

End Sub

'***********************Reader Json File*********************************

Sub Read_JSONfile(file_name As String) As ResumableSub
	
	Dim JSON As JSONParser
	ReadJsonList.Initialize
	ReadJsonList.Clear
	Try
		JSON.Initialize(File.ReadString(File.DirDefaultExternal, file_name))
		ReadJsonList = JSON.NextArray
		Return ReadJsonList
	Catch
		Log(LastException)
		Return ReadJsonList
	End Try
	
		
End Sub

'***********************Write Json File*********************************

Sub Write_Json_File(file_name As String,StringMap As String)As ResumableSub
		
	Try
		File.WriteString(File.DirDefaultExternal,file_name,StringMap)
		Return True
	Catch
		ToastMessageShow("Sauvegarde impossible", True)
		Return False
	End Try
	
End Sub
 
 '**************************Read Txt File *******************************
 	
Sub read_file_setup(file_name As String) As ResumableSub
	
	Dim reader As TextReader
		

If Main.type_transfert=Transfert_Server.Download_Setup_HH Then 'Chargement du Setup dans un Array
		
		Main.list_Read_Setup.Clear
		
		Try
			
			reader.Initialize(File.Openinput(File.DirDefaultExternal, file_name))
			Main.list_Read_Setup = reader.ReadList
			reader.Close
			If Main.list_Read_Setup.Size=0 Then
				Return False
			Else
				Return True
			End If
		Catch
			Return False
			ToastMessageShow("Lecture du Setup impossible", True)
		End Try
		
	Else if Main.type_transfert= Transfert_Server.Download_Conf_HH Then 'Chargement de la Conf dans un Array
		
		Main.list_Read_Conf.clear
		
		Try
			
			reader.Initialize(File.Openinput(File.DirDefaultExternal, file_name))
			Main.list_Read_Conf = reader.ReadList
			reader.Close
			If Main.list_Read_Conf.Size=0 Then
				Return False
			Else
				Return True
			End If
		Catch
			Return False
			ToastMessageShow("Lecture de la Localisation impossible", True)
		End Try
		
	Else if Main.type_transfert= Cockpit.Load_Data_SAV_HH Then 'Chargement des dernières data sauvegardées dans un Array
		
		'Main.list_Read_data_sav.clear
		
		Try
			
			reader.Initialize(File.Openinput(File.DirDefaultExternal, file_name))
			Main.list_Read_data_sav = reader.ReadList
			reader.Close
			If Main.list_Read_data_sav.Size=0 Then
				Return False
			Else
				Return True
			End If
			
		Catch
			Return False
			ToastMessageShow("Lecture des donnnées sauvegardées impossible", True)
		End Try
		
	Else if Main.type_transfert= Transfert_Server.Download_Account Then 'Chargement des dernières data sauvegardées dans un Array
		
		'Main.list_Read_data_sav.clear
		
		Try
			
			reader.Initialize(File.Openinput(File.DirDefaultExternal, file_name))
			Main.Autorisation = reader.ReadLine
			reader.Close
			
			If Main.Autorisation="" Then
				Return False
			Else
				Return True
			End If
			
		Catch
			Return False
			ToastMessageShow("Impossible d'identifier le compte", True)
		End Try
		
	Else if Main.type_transfert=Transfert_Server.UploadAccoutHHDOne Then
		Try
			
			reader.Initialize(File.Openinput(File.DirDefaultExternal, file_name))
			Main.DataTempFileLogin = reader.ReadLine
			reader.Close
			Return True
			
		Catch
			Return False
			ToastMessageShow("Impossible d'identifier le compte", True)
		End Try
	Else if Main.type_transfert= Transfert_Server.Download_ReturnHHDOne Then
		Try
			
			reader.Initialize(File.Openinput(File.DirDefaultExternal, file_name))
			Main.ResponseHHDOne = reader.ReadLine
			reader.Close
			Return True
			
		Catch
			Return False
			'ToastMessageShow("Impossible d'identifier le compte", True)
		End Try
	End If
	
	Return False
	

End Sub

'******************************Create Json File Setup***************************

Sub Json_Setup(Mode As Boolean) As ResumableSub
	
	Dim jg As JSONGenerator
	
	Try
				
		Dim Size As Int = Main.list_Read_Setup.Size
		
		Dim Info_Pilote(Size) As Map
		
		Dim Array_Map(Size) As Map
					
		Dim list_map As List
		list_map.Initialize
				
		For Each value_P In Main.list_Read_Setup
			
			Dim index_map As Int =Main.list_Read_Setup.IndexOf(value_P)
			Info_Pilote(index_map).Initialize
			Array_Map(index_map).Initialize
			Dim Array_P() As String= Regex.Split(";",value_P)
			
			If Array_P.Length=4 Then
				Info_Pilote(index_map).Put("Localisation",Array_P(1))
				Info_Pilote(index_map).Put("SensorMacAddress",Array_P(2))
				Info_Pilote(index_map).Put("MaxTemp",Array_P(3))'Temp Max
				'Prise 1
				Info_Pilote(index_map).Put("DeviceMacAddress","")
				Info_Pilote(index_map).Put("PowerIP","")
				Info_Pilote(index_map).Put("Type","") ' Type device
				Info_Pilote(index_map).Put("Pilote","-") 'Pilotage oui/non
				Info_Pilote(index_map).Put("Control_Type","") ' Manuel ou limitation
				Info_Pilote(index_map).Put("SetTemp","") ' Set Temp
				'Prise 2
				Info_Pilote(index_map).Put("@DeviceMacAddress","")
				Info_Pilote(index_map).Put("@PowerIP","")
				Info_Pilote(index_map).Put("@Type","") ' Type device
				Info_Pilote(index_map).Put("@Pilote","") 'Pilotage oui/non
				Info_Pilote(index_map).Put("@Control_Type","") ' Manuel ou limitation
				Info_Pilote(index_map).Put("@SetTemp","") ' Set Temp
			Else If Array_P.Length=10 Then '1 Prise connectée
				Info_Pilote(index_map).Put("Localisation",Array_P(1))
				Info_Pilote(index_map).Put("SensorMacAddress",Array_P(2))
				Info_Pilote(index_map).Put("MaxTemp",Array_P(3))'Temp Max
				'Prise 1
				Info_Pilote(index_map).Put("DeviceMacAddress",Array_P(4))
				Info_Pilote(index_map).Put("PowerIP",Array_P(5))
				Info_Pilote(index_map).Put("Type",Array_P(6)) ' Type device
				Info_Pilote(index_map).Put("Pilote",Array_P(7)) 'Pilotage oui/non
				Info_Pilote(index_map).Put("Control_Type",Array_P(8)) ' Manuel ou limitation
				Info_Pilote(index_map).Put("SetTemp",Array_P(9)) ' Set Temp
				'Prise 2
				Info_Pilote(index_map).Put("@DeviceMacAddress","")
				Info_Pilote(index_map).Put("@PowerIP","")
				Info_Pilote(index_map).Put("@Type","") ' Type device
				Info_Pilote(index_map).Put("@Pilote","") 'Pilotage oui/non
				Info_Pilote(index_map).Put("@Control_Type","") ' Manuel ou limitation
				Info_Pilote(index_map).Put("@SetTemp","") ' Set Temp
			Else If Array_P.Length=16 Then '2 prises connectées
				Info_Pilote(index_map).Put("Localisation",Array_P(1))
				Info_Pilote(index_map).Put("SensorMacAddress",Array_P(2))
				Info_Pilote(index_map).Put("MaxTemp",Array_P(3))'Temp Max
				'Prise 1
				Info_Pilote(index_map).Put("DeviceMacAddress",Array_P(4))
				Info_Pilote(index_map).Put("PowerIP",Array_P(5))
				Info_Pilote(index_map).Put("Type",Array_P(6)) ' Type device
				Info_Pilote(index_map).Put("Pilote",Array_P(7)) 'Pilotage oui/non
				Info_Pilote(index_map).Put("Control_Type",Array_P(8)) ' Manuel ou limitation
				Info_Pilote(index_map).Put("SetTemp",Array_P(9)) ' Set Temp
				'Prise 2
				Info_Pilote(index_map).Put("@DeviceMacAddress",Array_P(10))
				Info_Pilote(index_map).Put("@PowerIP",Array_P(11))
				Info_Pilote(index_map).Put("@Type",Array_P(12)) ' Type device
				Info_Pilote(index_map).Put("@Pilote",Array_P(13)) 'Pilotage oui/non
				Info_Pilote(index_map).Put("@Control_Type",Array_P(14)) ' Manuel ou limitation
				Info_Pilote(index_map).Put("@SetTemp",Array_P(15)) ' Set Temp
			End If
			
			
			Array_Map(index_map).Put("Pilote " & Array_P(0),Info_Pilote(index_map))
			list_map.Add(Array_Map(index_map))
		Next
		
		'jg.Initialize(CreateMap( "HH_Setup" : Array_Map))
		jg.Initialize2(list_map)
		Write_Json_File(Main.Localisation_Home & "_" & "setup.json",jg.ToPrettyString(4))
		Return True
			
	Catch
		Log(LastException)
		Return False
	End Try
		
	Return False
	
End Sub

'****************Creation Json Parameter ********************

Sub Json_Parameters(CdeType As Int) As ResumableSub
	
	Dim jg As JSONGenerator
	
	Try
							
		Dim MapParameter As Map
		MapParameter.Initialize
		
		Select Case CdeType
			Case Main.Init
				MapParameter.Put("AccessType","") 'MonthlyAccess, FreeAccess, YearlyAccess
				MapParameter.Put("SubscriptionType","") 'Personnal, Rental, Rental+, Full
				MapParameter.Put("Duration","")
				MapParameter.Put("FirstDate","")
				MapParameter.Put("LastDate","")
				MapParameter.Put("Status","") 'Actived, Locked
				MapParameter.Put("NumberOfSensor","")
				MapParameter.Put("NumberOfPower","")
				MapParameter.Put("NumberOfBeacon","")
				MapParameter.Put("MailAccount",Main.RepAccount)
				MapParameter.Put("MainHHDOneMacAddress",Main.Macadd)
				MapParameter.Put("HHDOneMacAddress2","")
				MapParameter.Put("HHDOneMacAddress3","")
				MapParameter.Put("SoftReleaseServer","")
				MapParameter.Put("SoftReleaseCustomer",Application.VersionCode)
				MapParameter.Put("SoftReleaseHHDOneServer","")
				MapParameter.Put("SoftReleaseHHDOneCustomer","")
				MapParameter.Put("SoftReleaseHHDOneCustomer2","")
				MapParameter.Put("SoftReleaseHHDOneCustomer3","")
				
			Case Main.AddPower
				MapParameter.Put("NumberOfPower","")
			Case Main.AddSensor
				MapParameter.Put("NumberOfSensor","")
		End Select
												
		jg.Initialize(MapParameter)
		Write_Json_File(Main.RepAccount & ".json",jg.ToPrettyString(4))
		Return True
			
	Catch
		Log(LastException)
		Return False
	End Try
		
	Return False
	
End Sub

'***********************Reader Json File  Parameters*********************************

Sub Read_JSONfileMap(file_name As String) As ResumableSub
	
	Dim JSON As JSONParser
	ParamMap.Initialize
	ParamMap.Clear
	
	Try
		JSON.Initialize(File.ReadString(File.DirDefaultExternal, file_name))
		
		ParamMap = JSON.NextObject
		Return ParamMap
	Catch
		Log(LastException)
		Return ParamMap
	End Try
	
		
End Sub


' ***************************Module Encryption**************************

Sub encryt_file (datatoencrypt As String,file_to_encrypt As String)
	
	Dim key(0) As Byte
	Dim data(0) As Byte
	Dim iv(0) As Byte
	
	
	'Log(PI.GetDeviceId)
	
	Dim pwd As String
	If PI.SdkVersion >= 29 Then
		pwd =PI.GetSettings("android_id")
	Else
		pwd  = pi1.GetDeviceId & "F"
	End If
	
	
	
	
	iv=Bconv.StringToBytes(pwd, "UTF8")
		
	Dim kg As KeyGenerator
	Dim c As Cipher
	c.Initialize("AES/CBC/PKCS5Padding")
	c.InitialisationVector = iv
	kg.Initialize("AES")
	kg.KeyFromBytes(iv)
	key = kg.KeyToBytes
		
	data = Bconv.StringToBytes(datatoencrypt, "UTF8")
	data = c.Encrypt(data, kg.Key, True)
		
	'écriture du fichier
	Dim writer As OutputStream=File.OpenOutput(File.DirDefaultExternal, file_to_encrypt,False)
	writer.WriteBytes(data,0,data.Length)
	writer.Close
	
	
	
	
End Sub

' ***************************Module Descryption**************************

Sub decrypt_file (type_file As Int, file_to_decrypt As String)
	
	Dim key(0) As Byte
	Dim data(0) As Byte
	Dim iv(0) As Byte
	Dim datatoencrypt As String=""
	'Log(PI.GetDeviceId)
	
	Dim pwd As String
	If PI.SdkVersion >= 29 Then
		pwd =PI.GetSettings("android_id")
	Else
		pwd  = pi1.GetDeviceId & "F"
	End If
	
	iv=Bconv.StringToBytes(pwd, "UTF8")
		
	Dim kg As KeyGenerator
	Dim c As Cipher
	c.Initialize("AES/CBC/PKCS5Padding")
	c.InitialisationVector = iv
	kg.Initialize("AES")
	kg.KeyFromBytes(iv)
	key = kg.KeyToBytes
		
	' Lecture du fichier
	Dim reader As InputStream = File.OpenInput(File.DirDefaultExternal, file_to_decrypt)
	Dim return_data(reader.BytesAvailable) As Byte
	
	reader.ReadBytes(return_data,0,reader.BytesAvailable)
	data = c.Decrypt(return_data, kg.Key, True)
	datatoencrypt=Bconv.StringFromBytes(data, "UTF8")
	reader.close
	
	'Charge les données dans les variables destinataires
		
	Select Case type_file
		
'		Case Type_Param_init
'			read_data_param=datatoencrypt
'		Case Type_collecte_cx_MMAT
'			Dim info_file() As String
'			info_file= Regex.Split(Chr(13) & Chr(10),Bconv.StringFromBytes(data, "UTF8"))
'			Main.data_collecte.Initialize
'			Main.data_collecte.Clear
'			Main.data_collecte.AddAll(info_file)
'		Case Type_collecte_Foyer_MMAT
'			Dim info_file() As String
'			info_file= Regex.Split(Chr(13) & Chr(10),Bconv.StringFromBytes(data, "UTF8"))
'			Main.data_collecte_foyer.Initialize
'			Main.data_collecte_foyer.Clear
'			Main.data_collecte_foyer.AddAll(info_file)
'		Case Type_collecte_cx_PaME
'			Dim info_file() As String
'			info_file= Regex.Split(Chr(13) & Chr(10),Bconv.StringFromBytes(data, "UTF8"))
'			Main.data_collecte.Initialize
'			Main.data_collecte.Clear
'			Main.data_collecte.AddAll(info_file)
'		Case Type_collecte_Foyer_PaME
'			Dim info_file() As String
'			info_file= Regex.Split(Chr(13) & Chr(10),Bconv.StringFromBytes(data, "UTF8"))
'			Main.data_collecte_foyer.Initialize
'			Main.data_collecte_foyer.Clear
'			Main.data_collecte_foyer.AddAll(info_file)
'		Case Type_Collecte_reg_st
'			Dim info_file() As String
'			info_file= Regex.Split(Chr(13) & Chr(10),Bconv.StringFromBytes(data, "UTF8"))
'			Main.data_reg_st.Initialize
'			Main.data_reg_st.Clear
'			Main.data_reg_st.AddAll(info_file)
'		Case Type_Collecte_hist_7j
'			Dim info_file() As String
'			info_file= Regex.Split(Chr(13) & Chr(10),Bconv.StringFromBytes(data, "UTF8"))
'			Main.data_filehisto7j.Initialize
'			Main.data_filehisto7j.Clear
'			Main.data_filehisto7j.AddAll(info_file)
				
	End Select
	
		
	
End Sub